/* NetworkInfoBar.c generated by valac 0.48.14, the Vala compiler
 * generated from NetworkInfoBar.vala, do not modify */

/*
* Copyright © 2019–2021 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define EPHEMERAL_TYPE_NETWORK_INFO_BAR (ephemeral_network_info_bar_get_type ())
#define EPHEMERAL_NETWORK_INFO_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EPHEMERAL_TYPE_NETWORK_INFO_BAR, EphemeralNetworkInfoBar))
#define EPHEMERAL_NETWORK_INFO_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EPHEMERAL_TYPE_NETWORK_INFO_BAR, EphemeralNetworkInfoBarClass))
#define EPHEMERAL_IS_NETWORK_INFO_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EPHEMERAL_TYPE_NETWORK_INFO_BAR))
#define EPHEMERAL_IS_NETWORK_INFO_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EPHEMERAL_TYPE_NETWORK_INFO_BAR))
#define EPHEMERAL_NETWORK_INFO_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EPHEMERAL_TYPE_NETWORK_INFO_BAR, EphemeralNetworkInfoBarClass))

typedef struct _EphemeralNetworkInfoBar EphemeralNetworkInfoBar;
typedef struct _EphemeralNetworkInfoBarClass EphemeralNetworkInfoBarClass;
typedef struct _EphemeralNetworkInfoBarPrivate EphemeralNetworkInfoBarPrivate;
enum  {
	EPHEMERAL_NETWORK_INFO_BAR_0_PROPERTY,
	EPHEMERAL_NETWORK_INFO_BAR_NUM_PROPERTIES
};
static GParamSpec* ephemeral_network_info_bar_properties[EPHEMERAL_NETWORK_INFO_BAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _EphemeralNetworkInfoBar {
	GtkInfoBar parent_instance;
	EphemeralNetworkInfoBarPrivate * priv;
};

struct _EphemeralNetworkInfoBarClass {
	GtkInfoBarClass parent_class;
};

static gpointer ephemeral_network_info_bar_parent_class = NULL;
extern GSettings* ephemeral_application_settings;

GType ephemeral_network_info_bar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EphemeralNetworkInfoBar, g_object_unref)
EphemeralNetworkInfoBar* ephemeral_network_info_bar_new (void);
EphemeralNetworkInfoBar* ephemeral_network_info_bar_construct (GType object_type);
static void ephemeral_network_info_bar_try_set_revealed (EphemeralNetworkInfoBar* self,
                                                  gboolean* reveal);
static GObject * ephemeral_network_info_bar_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void _ephemeral_network_info_bar___lambda35_ (EphemeralNetworkInfoBar* self,
                                              gint response_id);
static void __ephemeral_network_info_bar___lambda35__gtk_info_bar_response (GtkInfoBar* _sender,
                                                                     gint response_id,
                                                                     gpointer self);
static void _ephemeral_network_info_bar___lambda36_ (EphemeralNetworkInfoBar* self);
static void __ephemeral_network_info_bar___lambda36__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                                                 gboolean network_available,
                                                                                 gpointer self);
static GType ephemeral_network_info_bar_get_type_once (void);

EphemeralNetworkInfoBar*
ephemeral_network_info_bar_construct (GType object_type)
{
	EphemeralNetworkInfoBar * self = NULL;
	self = (EphemeralNetworkInfoBar*) g_object_new (object_type, "message-type", GTK_MESSAGE_WARNING, "show-close-button", TRUE, NULL);
	return self;
}

EphemeralNetworkInfoBar*
ephemeral_network_info_bar_new (void)
{
	return ephemeral_network_info_bar_construct (EPHEMERAL_TYPE_NETWORK_INFO_BAR);
}

static void
ephemeral_network_info_bar_try_set_revealed (EphemeralNetworkInfoBar* self,
                                             gboolean* reveal)
{
	gboolean network_available = FALSE;
	GNetworkMonitor* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_network_monitor_get_default ();
	network_available = g_network_monitor_get_network_available (_tmp0_);
	if (*reveal) {
		GSettings* _tmp3_;
		_tmp3_ = ephemeral_application_settings;
		_tmp2_ = g_settings_get_boolean (_tmp3_, "warn-network");
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = !network_available;
	} else {
		_tmp1_ = FALSE;
	}
	gtk_info_bar_set_revealed ((GtkInfoBar*) self, _tmp1_);
}

static void
_ephemeral_network_info_bar___lambda35_ (EphemeralNetworkInfoBar* self,
                                         gint response_id)
{
	GError* _inner_error0_ = NULL;
	switch (response_id) {
		case GTK_RESPONSE_ACCEPT:
		{
			{
				g_app_info_launch_default_for_uri ("settings://network", NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp0_;
				const gchar* _tmp1_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp0_ = e;
				_tmp1_ = _tmp0_->message;
				g_critical ("NetworkInfoBar.vala:57: %s", _tmp1_);
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			break;
		}
		case GTK_RESPONSE_REJECT:
		{
			GSettings* _tmp2_;
			_tmp2_ = ephemeral_application_settings;
			g_settings_set_boolean (_tmp2_, "warn-network", FALSE);
		}
		case GTK_RESPONSE_CLOSE:
		{
			gtk_info_bar_set_revealed ((GtkInfoBar*) self, FALSE);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static void
__ephemeral_network_info_bar___lambda35__gtk_info_bar_response (GtkInfoBar* _sender,
                                                                gint response_id,
                                                                gpointer self)
{
	_ephemeral_network_info_bar___lambda35_ ((EphemeralNetworkInfoBar*) self, response_id);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_ephemeral_network_info_bar___lambda36_ (EphemeralNetworkInfoBar* self)
{
	gboolean _tmp0_;
	_tmp0_ = TRUE;
	ephemeral_network_info_bar_try_set_revealed (self, &_tmp0_);
}

static void
__ephemeral_network_info_bar___lambda36__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                                            gboolean network_available,
                                                                            gpointer self)
{
	_ephemeral_network_info_bar___lambda36_ ((EphemeralNetworkInfoBar*) self);
}

static GObject *
ephemeral_network_info_bar_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	EphemeralNetworkInfoBar * self;
	gchar* title = NULL;
	gchar* _tmp0_;
	gchar* details = NULL;
	gchar* _tmp1_;
	GtkLabel* default_label = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkLabel* _tmp6_ = NULL;
	GtkLabel* _tmp7_;
	GtkButton* never_button = NULL;
	GtkButton* _tmp8_ = NULL;
	GtkButton* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkContainer* _tmp11_;
	GtkLabel* _tmp12_;
	GtkButton* _tmp13_;
	gboolean _tmp14_;
	GNetworkMonitor* network_monitor = NULL;
	GNetworkMonitor* _tmp15_;
	GNetworkMonitor* _tmp16_;
	GNetworkMonitor* _tmp17_;
	parent_class = G_OBJECT_CLASS (ephemeral_network_info_bar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EPHEMERAL_TYPE_NETWORK_INFO_BAR, EphemeralNetworkInfoBar);
	_tmp0_ = g_strdup (_ ("Network Not Available."));
	title = _tmp0_;
	_tmp1_ = g_strdup (_ ("Connect to the Internet to browse the Web."));
	details = _tmp1_;
	_tmp2_ = title;
	_tmp3_ = details;
	_tmp4_ = g_strdup_printf ("<b>%s</b> %s", _tmp2_, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
	gtk_label_set_use_markup (_tmp6_, TRUE);
	g_object_set (_tmp6_, "wrap", TRUE, NULL);
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	default_label = _tmp7_;
	_tmp8_ = (GtkButton*) gtk_button_new_with_label (_ ("Never Warn Again"));
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp8_);
	never_button = _tmp8_;
	_tmp9_ = never_button;
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
	gtk_style_context_add_class (_tmp10_, GTK_STYLE_CLASS_FLAT);
	_tmp11_ = gtk_info_bar_get_content_area ((GtkInfoBar*) self);
	_tmp12_ = default_label;
	gtk_container_add (_tmp11_, (GtkWidget*) _tmp12_);
	_tmp13_ = never_button;
	gtk_info_bar_add_action_widget ((GtkInfoBar*) self, (GtkWidget*) _tmp13_, (gint) GTK_RESPONSE_REJECT);
	gtk_info_bar_add_button ((GtkInfoBar*) self, _ ("Network Settings…"), (gint) GTK_RESPONSE_ACCEPT);
	_tmp14_ = TRUE;
	ephemeral_network_info_bar_try_set_revealed (self, &_tmp14_);
	g_signal_connect_object ((GtkInfoBar*) self, "response", (GCallback) __ephemeral_network_info_bar___lambda35__gtk_info_bar_response, self, 0);
	_tmp15_ = g_network_monitor_get_default ();
	_tmp16_ = _g_object_ref0 (_tmp15_);
	network_monitor = _tmp16_;
	_tmp17_ = network_monitor;
	g_signal_connect_object (_tmp17_, "network-changed", (GCallback) __ephemeral_network_info_bar___lambda36__g_network_monitor_network_changed, self, 0);
	_g_object_unref0 (network_monitor);
	_g_object_unref0 (never_button);
	_g_object_unref0 (default_label);
	_g_free0 (details);
	_g_free0 (title);
	return obj;
}

static void
ephemeral_network_info_bar_class_init (EphemeralNetworkInfoBarClass * klass,
                                       gpointer klass_data)
{
	ephemeral_network_info_bar_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = ephemeral_network_info_bar_constructor;
}

static void
ephemeral_network_info_bar_instance_init (EphemeralNetworkInfoBar * self,
                                          gpointer klass)
{
}

static GType
ephemeral_network_info_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EphemeralNetworkInfoBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ephemeral_network_info_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EphemeralNetworkInfoBar), 0, (GInstanceInitFunc) ephemeral_network_info_bar_instance_init, NULL };
	GType ephemeral_network_info_bar_type_id;
	ephemeral_network_info_bar_type_id = g_type_register_static (gtk_info_bar_get_type (), "EphemeralNetworkInfoBar", &g_define_type_info, 0);
	return ephemeral_network_info_bar_type_id;
}

GType
ephemeral_network_info_bar_get_type (void)
{
	static volatile gsize ephemeral_network_info_bar_type_id__volatile = 0;
	if (g_once_init_enter (&ephemeral_network_info_bar_type_id__volatile)) {
		GType ephemeral_network_info_bar_type_id;
		ephemeral_network_info_bar_type_id = ephemeral_network_info_bar_get_type_once ();
		g_once_init_leave (&ephemeral_network_info_bar_type_id__volatile, ephemeral_network_info_bar_type_id);
	}
	return ephemeral_network_info_bar_type_id__volatile;
}

